; SCROLL.ASM
; Handle the scrolling background


scroll_draw_line_of_tiles:

	ld a,(looping_end)
	cp 2
	ret z

	; I need to know HOW FAR AWAY I AM DRAWING THESE TILES
	; FROM THE TOP OF THE SCREEN.

	ld a,(cur_scroll_index)
	cp 200
	jr c,scroll_no_adjust_top
	sub 224
scroll_no_adjust_top:

	add a,32

	srl a
	srl a
	srl a

	dec a

	; Now, multiply by 64:

	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	push hl
	add hl,hl
	ld de,vram_names+12
	add hl,de
	call vid_goto_address

	ld hl,(cur_map_pos)
	ld de,decomp_level
	ld bc,20
	call rle
	ld (cur_map_pos),hl

	pop hl
	ld de,names_ram_copy+6
	add hl,de
	ld d,h
	ld e,l
	ld hl,decomp_level
	ld bc,20
	ldir

	ld hl,decomp_level
	ld b,20
write_line_of_map:
	ld a,(hl)
	out (vdp_data),a
	xor a
	out (vdp_data),a
	inc hl
	djnz write_line_of_map

	; Now we need to check to see if we've hit the end of the level or the face
	ld hl,(cur_map_pos)
	ld de,face_actual

	ld a,d
	cp h
	jr nz,+
	ld a,e
	cp l
	jr nz,+
	ld a,%00000011
	ld (land_speed),a
+:
	ld hl,(cur_map_pos)

	ld de,(cur_map_end)
	ld a,d
	cp h
	jr nz,+
	ld a,e
	cp l
	jr nz,+


	ld a,(cur_map_number)
	and %10000000
	jr z,is_face_ending


	; IS IT A PLATFORM ENDING?
	ld a,(looping_end)
	cp 1
	jr nz,not_flown_past_platform

	; We've flown past the platform
	ld a,2
	ld (shot_eyes),a
not_flown_past_platform:
	ld hl,map_platform
	ld (cur_map_pos),hl
	ld hl,map_platform_end
	ld (cur_map_end),hl
	jr has_set_ending_level

is_face_ending:
	ld hl,map_face
	ld (cur_map_pos),hl
	ld hl,map_face_end
	ld (cur_map_end),hl

has_set_ending_level:
	ld a,(looping_end)
	inc a
	ld (looping_end),a
	ret
+:
	ld de,map_platform_end
	ld a,d
	cp h
	ret nz
	ld a,l
	cp e
	ret nz
	ld hl,(real_level)
	ld (cur_map_pos),hl
	ret

scroll_one_line:
	ld a,(cur_scroll_index)
	dec a
	cp -1
	jr nz, scroll_no_fix_jumping
	ld a,223
scroll_no_fix_jumping:

	ld (cur_scroll_index),a

	push af
	and %00000111
	call z,scroll_draw_line_of_tiles
	pop af
	add a,16
	ld b,vdp_reg_scroll_y
	call vid_set_vdp_reg

	ret